<?php

namespace protec\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDLCPMCaseProduct ArrayType
 * @subpackage Arrays
 * @version 1.0
 * @date 2019/06/17
 * @author webdev
 */
class ArrayOfDLCPMCaseProduct extends AbstractStructArrayBase
{
    /**
     * The DLCPMCaseProduct
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \protec\StructType\DLCPMCaseProduct[]
     */
    public $DLCPMCaseProduct;
    /**
     * Constructor method for ArrayOfDLCPMCaseProduct
     * @uses ArrayOfDLCPMCaseProduct::setDLCPMCaseProduct()
     * @param \protec\StructType\DLCPMCaseProduct[] $dLCPMCaseProduct
     */
    public function __construct(array $dLCPMCaseProduct = array())
    {
        $this
            ->setDLCPMCaseProduct($dLCPMCaseProduct);
    }
    /**
     * Get DLCPMCaseProduct value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \protec\StructType\DLCPMCaseProduct[]|null
     */
    public function getDLCPMCaseProduct()
    {
        return isset($this->DLCPMCaseProduct) ? $this->DLCPMCaseProduct : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDLCPMCaseProduct method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDLCPMCaseProduct method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDLCPMCaseProductForArrayConstraintsFromSetDLCPMCaseProduct(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDLCPMCaseProductDLCPMCaseProductItem) {
            // validation for constraint: itemType
            if (!$arrayOfDLCPMCaseProductDLCPMCaseProductItem instanceof \protec\StructType\DLCPMCaseProduct) {
                $invalidValues[] = is_object($arrayOfDLCPMCaseProductDLCPMCaseProductItem) ? get_class($arrayOfDLCPMCaseProductDLCPMCaseProductItem) : sprintf('%s(%s)', gettype($arrayOfDLCPMCaseProductDLCPMCaseProductItem), var_export($arrayOfDLCPMCaseProductDLCPMCaseProductItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DLCPMCaseProduct property can only contain items of type \protec\StructType\DLCPMCaseProduct, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DLCPMCaseProduct value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \protec\StructType\DLCPMCaseProduct[] $dLCPMCaseProduct
     * @return \protec\ArrayType\ArrayOfDLCPMCaseProduct
     */
    public function setDLCPMCaseProduct(array $dLCPMCaseProduct = array())
    {
        // validation for constraint: array
        if ('' !== ($dLCPMCaseProductArrayErrorMessage = self::validateDLCPMCaseProductForArrayConstraintsFromSetDLCPMCaseProduct($dLCPMCaseProduct))) {
            throw new \InvalidArgumentException($dLCPMCaseProductArrayErrorMessage, __LINE__);
        }
        if (is_null($dLCPMCaseProduct) || (is_array($dLCPMCaseProduct) && empty($dLCPMCaseProduct))) {
            unset($this->DLCPMCaseProduct);
        } else {
            $this->DLCPMCaseProduct = $dLCPMCaseProduct;
        }
        return $this;
    }
    /**
     * Add item to DLCPMCaseProduct value
     * @throws \InvalidArgumentException
     * @param \protec\StructType\DLCPMCaseProduct $item
     * @return \protec\ArrayType\ArrayOfDLCPMCaseProduct
     */
    public function addToDLCPMCaseProduct(\protec\StructType\DLCPMCaseProduct $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \protec\StructType\DLCPMCaseProduct) {
            throw new \InvalidArgumentException(sprintf('The DLCPMCaseProduct property can only contain items of type \protec\StructType\DLCPMCaseProduct, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DLCPMCaseProduct[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \protec\StructType\DLCPMCaseProduct|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \protec\StructType\DLCPMCaseProduct|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \protec\StructType\DLCPMCaseProduct|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \protec\StructType\DLCPMCaseProduct|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \protec\StructType\DLCPMCaseProduct|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DLCPMCaseProduct
     */
    public function getAttributeName()
    {
        return 'DLCPMCaseProduct';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \protec\ArrayType\ArrayOfDLCPMCaseProduct
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
