<?php

namespace protec\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPracticeDoctorInfo ArrayType
 * @subpackage Arrays
 * @version 1.0
 * @date 2019/06/17
 * @author webdev
 */
class ArrayOfPracticeDoctorInfo extends AbstractStructArrayBase
{
    /**
     * The PracticeDoctorInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \protec\StructType\PracticeDoctorInfo[]
     */
    public $PracticeDoctorInfo;
    /**
     * Constructor method for ArrayOfPracticeDoctorInfo
     * @uses ArrayOfPracticeDoctorInfo::setPracticeDoctorInfo()
     * @param \protec\StructType\PracticeDoctorInfo[] $practiceDoctorInfo
     */
    public function __construct(array $practiceDoctorInfo = array())
    {
        $this
            ->setPracticeDoctorInfo($practiceDoctorInfo);
    }
    /**
     * Get PracticeDoctorInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \protec\StructType\PracticeDoctorInfo[]|null
     */
    public function getPracticeDoctorInfo()
    {
        return isset($this->PracticeDoctorInfo) ? $this->PracticeDoctorInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPracticeDoctorInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPracticeDoctorInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePracticeDoctorInfoForArrayConstraintsFromSetPracticeDoctorInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPracticeDoctorInfoPracticeDoctorInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfPracticeDoctorInfoPracticeDoctorInfoItem instanceof \protec\StructType\PracticeDoctorInfo) {
                $invalidValues[] = is_object($arrayOfPracticeDoctorInfoPracticeDoctorInfoItem) ? get_class($arrayOfPracticeDoctorInfoPracticeDoctorInfoItem) : sprintf('%s(%s)', gettype($arrayOfPracticeDoctorInfoPracticeDoctorInfoItem), var_export($arrayOfPracticeDoctorInfoPracticeDoctorInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PracticeDoctorInfo property can only contain items of type \protec\StructType\PracticeDoctorInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PracticeDoctorInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \protec\StructType\PracticeDoctorInfo[] $practiceDoctorInfo
     * @return \protec\ArrayType\ArrayOfPracticeDoctorInfo
     */
    public function setPracticeDoctorInfo(array $practiceDoctorInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($practiceDoctorInfoArrayErrorMessage = self::validatePracticeDoctorInfoForArrayConstraintsFromSetPracticeDoctorInfo($practiceDoctorInfo))) {
            throw new \InvalidArgumentException($practiceDoctorInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($practiceDoctorInfo) || (is_array($practiceDoctorInfo) && empty($practiceDoctorInfo))) {
            unset($this->PracticeDoctorInfo);
        } else {
            $this->PracticeDoctorInfo = $practiceDoctorInfo;
        }
        return $this;
    }
    /**
     * Add item to PracticeDoctorInfo value
     * @throws \InvalidArgumentException
     * @param \protec\StructType\PracticeDoctorInfo $item
     * @return \protec\ArrayType\ArrayOfPracticeDoctorInfo
     */
    public function addToPracticeDoctorInfo(\protec\StructType\PracticeDoctorInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \protec\StructType\PracticeDoctorInfo) {
            throw new \InvalidArgumentException(sprintf('The PracticeDoctorInfo property can only contain items of type \protec\StructType\PracticeDoctorInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PracticeDoctorInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \protec\StructType\PracticeDoctorInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \protec\StructType\PracticeDoctorInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \protec\StructType\PracticeDoctorInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \protec\StructType\PracticeDoctorInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \protec\StructType\PracticeDoctorInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PracticeDoctorInfo
     */
    public function getAttributeName()
    {
        return 'PracticeDoctorInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \protec\ArrayType\ArrayOfPracticeDoctorInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
