<?php

namespace protec\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Add ServiceType
 * @subpackage Services
 * @version 1.0
 * @date 2019/06/17
 * @author webdev
 */
class Add extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named AddCase
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \protec\StructType\AddCase $parameters
     * @return \protec\StructType\AddCaseResponse|bool
     */
    public function AddCase(\protec\StructType\AddCase $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->AddCase($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named AddCaseDocument
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \protec\StructType\AddCaseDocument $parameters
     * @return \protec\StructType\AddCaseDocumentResponse|bool
     */
    public function AddCaseDocument(\protec\StructType\AddCaseDocument $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->AddCaseDocument($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named AddCallNote
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \protec\StructType\AddCallNote $parameters
     * @return \protec\StructType\AddCallNoteResponse|bool
     */
    public function AddCallNote(\protec\StructType\AddCallNote $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->AddCallNote($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named AddCaseLog
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \protec\StructType\AddCaseLog $parameters
     * @return \protec\StructType\AddCaseLogResponse|bool
     */
    public function AddCaseLog(\protec\StructType\AddCaseLog $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->AddCaseLog($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \protec\StructType\AddCallNoteResponse|\protec\StructType\AddCaseDocumentResponse|\protec\StructType\AddCaseLogResponse|\protec\StructType\AddCaseResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
